Bug 181194 - Speed-up computation of retained sizes
Speed-up computation of retained sizes
Status: RESOLVED FIXED
Product: profiler
Classification: Unclassified
Component: Base
6.x
All All
: P2 (vote)
: 7.2
Assigned To: Tomas Hurka
issues@profiler
bugdb_13600505
: VISUALVM
Depends on: 207728
Blocks:
  Show dependency treegraph
 
Reported: 2010-02-25 05:45 UTC by Egor Ushakov
Modified: 2012-09-27 15:08 UTC (History)
0 users

See Also:
Issue Type: ENHANCEMENT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Egor Ushakov 2010-02-25 05:45:05 UTC
Process of computing retained sizes takes very long time and it is serial (uses only one core of my 4 core cpu), can that be performed in parallel and so faster?
Comment 1 Egor Ushakov 2010-02-25 06:24:01 UTC
Still analyzing crash dump.
So far I can see lots of StreamTerm.OutputMonitor threads alive...
Comment 2 Tomas Hurka 2010-02-25 06:38:37 UTC
I am not sure if this is possible. It will be better to improve the algorithm. Note that GC can run in parallel with the computation.
Comment 3 Egor Ushakov 2010-02-25 06:46:54 UTC
please do not pay attention to the comment about crash dump - wrong IZ, sorry
Comment 4 Tomas Hurka 2010-02-25 07:01:08 UTC
I did not. I already thought that this comment was attached to wrong IZ.
Comment 5 Jiri Sedlacek 2012-01-23 11:13:16 UTC
From the related bugdb:

"Open uploaded hprof 
Click Find button, to see the top retained objects 
Bug: Takes 15 mins"

--

"I'm using my 64bit Linux box. I have not changed the memory IDE uses.

I can open the same file on Windows in YourKit in 1m30s, Initializing Statics
takes 16s. Click calculating exact retained size for the top 10 takes 10s.

In addition to this it's 15 mins every time I want to look at the dump."
Comment 6 Tomas Hurka 2012-02-23 12:48:33 UTC
changeset:   213536:66c61c15f53c
user:        Tomas Hurka <thurka@netbeans.org>
date:        Thu Feb 23 13:42:00 2012 +0100
summary:     issue #181194, improve efficiency of dirtySet cache

changeset:   213535:61322416909d
user:        Tomas Hurka <thurka@netbeans.org>
date:        Thu Feb 23 13:39:51 2012 +0100
summary:     issue #181194, memory map NumberList data, once they will not grow too much

The above fixes improved retained size computation (including references and GC roots) on tested heap dump from 717 seconds to 232 seconds.
Comment 7 Quality Engineering 2012-02-28 10:51:30 UTC
Integrated into 'main-golden', will be available in build *201202280400* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/61322416909d
User: Tomas Hurka <thurka@netbeans.org>
Log: issue #181194, memory map NumberList data, once they will not grow too much
Comment 8 Tomas Hurka 2012-03-19 13:33:29 UTC
Done for 7.2.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo